﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'Dim file_Data As String = "Data_Live_Sensor.txt"
	Dim Mesure_delay As Int= 30 'Mn
	Dim Command_Delay As Int = 1 'Mn
	Dim data_list As List
	Dim Time_Agent_command As Long= DateTime.Now
	Dim Time_Agent As Long= DateTime.Now
	Dim bat_force As Boolean=False
	Dim type_file As Int
	Dim SETUP_FILE, COMMAND_FILE, DATA_SENSOR_FILE, INFO_BATTERY As Int
	Dim read_info_bat As Boolean=False
	Dim delta As Long
	
	SETUP_FILE = 1
	COMMAND_FILE = 2
	DATA_SENSOR_FILE = 3
	INFO_BATTERY = 4
End Sub

Sub Service_Create
	Log("Agent actif")
	
	data_list.Initialize
	data_list.Clear
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	
	Try
		DateTime.DateFormat="hh:mm:ss"
		'Dim date_file As Long =File.LastModified(File.DirDefaultExternal,file_Data)
		delta = Round2(((Mesure_delay*60000)- (DateTime.Now - Time_Agent))/60000,0)
	
		Log(Round2(((Mesure_delay*60000)- (DateTime.Now - Time_Agent))/60000,0) & "mn")
	
		If DateTime.Now - Time_Agent > (Mesure_delay*60000) And IsPaused(Collecte_data_sensor)=True Then 'Récupère les infos des sensors
			Time_Agent = DateTime.Now
			type_file= DATA_SENSOR_FILE
			StartService(Collecte_data_sensor)
		
		Else If DateTime.Now - Time_Agent_command > (Command_Delay*60000) And IsPaused(Collecte_data_sensor)=True Then ' Scan si une requête est demandée par le serveur
		
			Time_Agent_command = DateTime.Now
			type_file= COMMAND_FILE
			StartService(Collecte_data_sensor)
		
			If Main.main_actif=True Then
				CallSub2(Main,"log1",2)
			End If
		
		Else if Round2(((Mesure_delay*60000)- (DateTime.Now - Time_Agent))/60000,0) < 0 Then 'Force l'arrêt du service s'il est bloqué
			Log("Arrêt forcé du service")
			StopService(Collecte_data_sensor)
		Else
			If Main.main_actif=True Then 'Agent en attente
				CallSub2(Main,"log1",0)
			End If
		End If
	
		' Recupération du niveau de batterie
'		If (DateTime.GetHour(DateTime.Now)=22 And DateTime.GetMinute(DateTime.Now)<15 And read_info_bat=False) Or bat_force=True Then
'			type_file=INFO_BATTERY
'			read_info_bat=True
'			bat_force=False
'			StartService(Collecte_data_sensor)
'		Else if DateTime.GetHour(DateTime.Now)=22 And DateTime.GetMinute(DateTime.Now)>15 Then
'			read_info_bat=False
'		End If
	Catch
		Log(LastException)
	End Try
	
		
	StartServiceAt(Me,DateTime.Now + 2000,True) ' Relance de l'agent toutes les 2s
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
	StopService(Me)
	
End Sub

Sub Service_Destroy

End Sub
